<?php

/**
 * @file
 * Contains \Drupal\miniorange_saml_idp\Form\MiniorangeSPInformation.
 */

namespace Drupal\miniorange_saml_idp\Form;

use Drupal\Core\Form\FormBase;
use Drupal\miniorange_saml_idp\Utilities;

class MiniorangeCustomCertificate extends FormBase
{

    public function getFormId()
    {
        return 'miniorange_custom_certificate';
    }

    public function buildForm(array $form, \Drupal\Core\Form\FormStateInterface $form_state)
    {

        global $base_url;

        $form['header_top_style_1'] = array('#markup' => '<div class="mo_saml_table_layout_1"><div class="mo_saml_table_layout mo_saml_container">');


        $form['miniorange_saml_SP_tab_cert'] = array(
            '#attached' => array(
                'library' => array(
                    'miniorange_saml_idp/miniorange_saml_idp.Vtour',
                )
            ),
        );

        $form['markup_1'] = array(
            '#markup' => '<h3>ADD CUSTOM CERTIFICATE </h3><hr><br/>',
        );


        $form['miniorange_saml_idp_custom_cert_settings'] = array(
            '#markup' => '<div class = mo_saml_highlight_background_note><b>NOTE: </b>This tab will help you to save and generate new certificates.
                        You can perform following operations:<br><br> 1. Copy your own certificates and save them to use it for SSO.<br>
                        2. You can generate new certificates and use them for SSO.<br> 3. Reset setting to get back default settings.</div><br><br>',
        );

        $form['miniorange_saml_idp_private_certificate'] = array(
            '#type' => 'textarea',
            '#title' => t('X.509 Private Certificate.<b><a href="' . $base_url . '/admin/config/people/miniorange_saml_idp/licensing"> [Premium]</a></b>'),
            '#cols' => 5,
            '#rows' => 5,
            '#attributes' => array('style' => 'width:77%;background-color: hsla(0,0%,0%,0.08) !important;', 'placeholder' => "Copy and Paste the content from the downloaded certificate or copy the content enclosed in X509Certificate tag (has parent tag KeyDescriptor use=signing) in IdP-Metadata XML file."),
            '#disabled' => $disabled,
        );

        $form['miniorange_saml_idp_cert_format1'] = array(
            '#markup' => '<strong>NOTE :</strong> Format of the certificate:<br /><strong>-----BEGIN PRIVATE KEY-----<br />'
                . 'XXXXXXXXXXXXXXXXXXXXXXXXXXX<br />-----END PRIVATE KEY-----</strong><br /><br /><br />',
        );

        $form['miniorange_saml_idp_publ_certificate'] = array(
            '#type' => 'textarea',
            '#title' => t('X.509 Public Certificate <b><a href="' . $base_url . '/admin/config/people/miniorange_saml_idp/licensing"> [Premium]</a></b>'),
            '#cols' => 5,
            '#rows' => 5,
            '#attributes' => array('style' => 'width:77%;background-color: hsla(0,0%,0%,0.08) !important;', 'placeholder' => "Copy and Paste the content from the downloaded certificate or copy the content enclosed in X509Certificate tag (has parent tag KeyDescriptor use=signing) in IdP-Metadata XML file."),
            '#disabled' => $disabled,
        );

        $form['miniorange_saml_idp_cert_format'] = array(
            '#markup' => '<strong>NOTE :</strong> Format of the certificate:<br /><strong>-----BEGIN CERTIFICATE-----<br />'
                . 'XXXXXXXXXXXXXXXXXXXXXXXXXXX<br />-----END CERTIFICATE-----</strong><br /><br /><br /><br />',
        );

        $form['save_config_elements'] = array(
            '#type' => 'submit',
            '#name' => 'submit',
            '#value' => t('Upload'),
            '#prefix' => '<td>',
            '#suffix' => '</td>',
            '#disabled' => TRUE,
            '#attributes' => array('style' => 'border-radius:4px;width:100px;background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;box-shadow: 0 1px 0 #337ab7;border-color: #337ab7 #337ab7 #337ab7;'),
        );

        $form['save_config_elements1'] = array(
            '#type' => 'submit',
            '#value' => t('Reset'),
            '#prefix' => '<td>',
            '#suffix' => '</td>',
            '#disabled' => TRUE,
            '#attributes' => array('style' => 'border-radius:4px;width:100px;background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;box-shadow: 0 1px 0 #337ab7;border-color: #337ab7 #337ab7 #337ab7;'),
        );


        $form['markup_idp_attr_header_top_div_close'] = array('#markup' => '</div>',);

        $form['miniorange_idp_guide_link'] = array(
            '#markup' => '<div class="mo_saml_table_layout mo_saml_container_2">',
        );

        $form['miniorange_idp_guide_link1'] = array(
            '#markup' => '<div style="font-size: 15px;"><b>To see detailed documentation of how to configure Drupal 7 SAML IdP with any Service Provider</b></div></br>',
        );

        Utilities::spConfigGuide($form, $form_state);

        $form['markup_div_imp11w'] = array('#markup' => '</div>');

        Utilities::AddSupportButton($form, $form_state);
        return $form;
    }

    public function submitForm(array &$form, \Drupal\Core\Form\FormStateInterface $form_state)
    {

    }
}
