<?php

/**
 * @file
 * Contains \Drupal\miniorange_saml_idp\Form\MiniorangeIDPSetup.
 */

namespace Drupal\miniorange_saml_idp\Form;
use Drupal\Core\Form\FormBase;
use Drupal\miniorange_saml_idp\Utilities;
use Drupal\miniorange_saml_idp\MetadataReader;

class MiniorangeIDPSetup extends FormBase {

  public function getFormId() {
    return 'miniorange_saml_idp_setup';
  }

  public function buildForm(array $form, \Drupal\Core\Form\FormStateInterface $form_state)
  {
      global $base_url;

      Utilities::visual_tour_start($form, $form_state);

      $form['markup_idp_header'] = array(
          '#markup' => '<div class="mo_saml_table_layout_1"><div class="mo_saml_table_layout mo_saml_container">',
      );

      $form['miniorange_saml_SP_tab'] = array(
          '#attached' => array(
              'library' => array(
                  'miniorange_saml_idp/miniorange_saml_idp.test',
                  'miniorange_saml_idp/miniorange_saml_idp.Vtour',
              )
          ),
          '#markup' => '<div id="tabhead"><br><h5> Enter the information gathered from your Service Provider &nbsp; OR &nbsp;&nbsp;
                    <a id="showMetaButton" class="btn btn-primary btn-sm" onclick="testConfig()">Upload SP Metadata</a>&nbsp;&nbsp;&nbsp;&nbsp;
                    <a id="Restart_moTour" class="btn btn-danger btn-sm" onclick="Restart_moTour()">Take a Tour</a>
                    <br></h5><hr></div>',
      );

      $form['metadata_1'] = array(
          '#markup' =>'<div border="1" id="upload_metadata_form" class="mo_saml_meta_upload">'
              .'				<h3>UPLOAD SP METADATA &nbsp;&nbsp;'
              .'		<span class="mo_saml_cancel_upload"><a id="hideMetaButton" class="btn btn-sm btn-danger" onclick = "testConfig()">Cancel</a></span><br><br><hr><hr>',
      );

      $form['metadata_idp_name'] = array(
          '#markup' => '<br><tr><td colspan="3" ></td></tr>'
              .'		    <tr>'
              .'			<td width="20%"><h4>Service Provider name:</h4></td><td width="10%">',
      );

      $form['miniorange_saml_idp_name_3'] = array(
          '#type' => 'textfield',
          '#attributes' => array('style' => 'width:65%','placeholder' => 'Enter Service Provider name'),
      );

      $form['metadata_2'] = array(
          '#markup' =>'<br><br></h1><h4>Upload Metadata  :</h4>',
      );

      $form['metadata_file'] = array(
          '#type' => 'file',
          '#attributes' => array('style' => 'width:65%'),
      );

      $form['metadata_upload'] = array(
          '#type' => 'submit',
          '#value' => t('Upload'),
          '#submit' => array('::miniorange_saml_upload_file'),
          '#attributes' => array('style' => 'border-radius:4px;background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;
            box-shadow: 0 1px 0 #337ab7;border-color: #337ab7 #337ab7 #337ab7;float: right;margin-top: -39px;width: 150px;'),
      );

      $form['metadata_3'] = array(
          '#markup' =>'<div class="mo_saml_text_center"><b>OR</b></div>'
              .'			<h4>Enter metadata URL:</h4>',

      );

      $form['metadata_URL'] = array(
          '#type' => 'textfield',
          '#attributes' => array('style' => 'width:65%','placeholder' => 'Enter metadata URL of your SP.'),
      );

      $form['metadata_fetch'] = array(
          '#type' => 'submit',
          '#value' => t('Fetch Metadata'),
          '#submit' => array('::miniorange_saml_fetch_metadata'),
          '#attributes' => array('style' => 'border-radius:4px;background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;
            box-shadow: 0 1px 0 #337ab7;border-color: #337ab7 #337ab7 #337ab7;float: right;margin-top: -39px;'),
      );

      $form['metadata_5'] = array(
          '#markup' =>'<br><br><br><br></div>'
              .'<div id="idpdata">',
      );

      $form['markup_idp_note'] = array(
        '#markup' => '<br><div class = "mo_saml_highlight_background_note"><b>Note: </b>Please note down the following information from your Service Provider'
      . ' and keep it handy to configure your Identity Provider.</div><br>',
      );

      $form['markup_idp_list'] = array(
            '#markup' => '<b><ol><li>SP Entity ID / Issuer</li>'
          . ' <li>ACS URL</li>'
          . ' <li>X.509 Certificate for Signing if you are using HTTP-POST Binding. [This is a'
          . ' <a href="' . $base_url . '/admin/config/people/miniorange_saml_idp/licensing">Premium</a> feature]</li>'
          . ' <li>X.509 Certificate for Encryption. [This is a'
          . ' <a href="' . $base_url . '/admin/config/people/miniorange_saml_idp/licensing">Premium</a> feature]</li>'
          . ' <li>NameID Format</li></ol></b><br />',
      );
        $form['markup_saml_idp_disabled'] = array(
          '#markup' => '<div>',
        );

      $form['miniorange_saml_idp_name'] = array(
        '#type' => 'textfield',
        '#title' => t('Service Provider Name*'),
        '#default_value' => \Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_idp_name'),
        '#attributes' => array(
              'style' => 'width:700px',
              'placeholder' => 'Service Provider Name'
        ),
      );

      $form['miniorange_saml_idp_entity_id'] = array(
        '#type' => 'textfield',
        '#title' => t('SP Entity ID or Issuer*'),
        '#description' => t('<b>Note :</b> You can find the EntityID in Your SP-Metadata XML file enclosed in <code>EntityDescriptor</code> tag having attribute as <code>entityID</code>.'),
        '#default_value' => \Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_idp_entity_id'),
        '#attributes' => array('style' => 'width:700px','placeholder' => 'SP Entity ID or Issuer'),
      );

      $form['miniorange_saml_idp_nameid_format'] = array(
        '#type' => 'select',
        '#title' => t('NameID Format:'),
        '#options' => array(
            '1.1:nameid-format:emailAddress' => t('urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress'),
            '1.1:nameid-format:unspecified' => t('urn:oasis:names:tc:SAML:1.1:nameid-format:unspecified'),
            '2.0:nameid-format:transient' => t('urn:oasis:names:tc:SAML:1.1:nameid-format:transient'),
            '2.0:nameid-format:persistent' => t('urn:oasis:names:tc:SAML:1.1:nameid-format:persistent'),
         ),
        '#default_value' =>\Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_idp_nameid_format'),
          '#attributes' => array('style' => 'width:700px;background-image: inherit;background-color: white;-webkit-appearance: menulist;'),
        '#description' => t('(<b>NOTE:</b> urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress is selected by default)'),
      );

      $form['miniorange_saml_idp_acs_url'] = array(
        '#type' => 'textfield',
        '#title' => t('ACS URL*'),
        '#description' => t('<b>Note :</b> You can find the SAML Login URL in Your SP-Metadata XML file enclosed in <code>AssertionConsumerService </code> tag <br/>having attribute as <code>Location</code>.'),
        '#default_value' => \Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_idp_acs_url'),
        '#attributes' => array('style' => 'width:700px','placeholder' => 'ACS URL'),
      );

      $form['miniorange_saml_idp_relay_state'] = array(
        '#type' => 'textfield',
        '#title' => t('Relay State'),
        '#default_value' => \Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_idp_relay_state'),
        '#attributes' => array('style' => 'width:700px','placeholder' => 'Relay State (optional)'),
      );

      $form['miniorange_saml_idp_single_logout_url'] = array(
          '#type' => 'textfield',
          '#title' => t('Single Logot URL (optional):<a href="' . $base_url . '/admin/config/people/miniorange_saml_idp/licensing"> [Premium]</a>'),
          '#attributes' => array('style' => 'width:700px','placeholder' => 'Sinle Logout URL'),
          '#disabled' => TRUE,
      );

      $form['miniorange_saml_idp_x509_certificate_request'] = array(
         '#type' => 'textarea',
         '#title' => t('x.509 Certificate Value  <b>[Note: For Signed Request.] </b><a href="' . $base_url . '/admin/config/people/miniorange_saml_idp/licensing"> [Premium]</a>'),
         '#cols' => '10',
         '#rows' => '5',
         '#attributes' => array('style' => 'width:700px','placeholder' => 'Copy and Paste the content from the downloaded certificate or copy the content enclosed in X509Certificate tag (has parent tag KeyDescriptor use=signing) in SP-Metadata XML file)'),
         '#disabled' => TRUE,
      );

      $form['markup_1'] = array(
         '#markup' => '<b>NOTE:</b> Format of the certificate:<br><b>-----BEGIN CERTIFICATE-----<br>'
          .'XXXXXXXXXXXXXXXXXXXXXXXXXXX<br>-----END CERTIFICATE-----</b>'
      );

      $form['miniorange_saml_idp_x509_certificate_assertion'] = array(
          '#type' => 'textarea',
          '#title' => t('x.509 Certificate Value <b>[Note: For Encrypted Assertion.]</b> <a href="' . $base_url . '/admin/config/people/miniorange_saml_idp/licensing"> [Premium]</a>'),
          '#cols' => '10',
          '#rows' => '5',
          '#attributes' => array('style' => 'width:700px','placeholder' => 'Copy and Paste the content from the downloaded certificate or copy the content enclosed in X509Certificate tag (has parent tag KeyDescriptor use=encryption)'),
          '#disabled' => TRUE,
      );

      $form['markup_2'] = array(
          '#markup' => '<b>NOTE:</b> Format of the certificate:<br><b>-----BEGIN CERTIFICATE-----<br>'
           .'XXXXXXXXXXXXXXXXXXXXXXXXXXX<br>-----END CERTIFICATE-----</b>'
      );

      $form['miniorange_saml_idp_assertion_back_color'] = array(
          '#markup' => '<div class="mo_saml_highlight_background_note">'
      );

      $form['miniorange_saml_idp_response_signed'] = array(
        '#markup' => '<br>',
        '#type' => 'checkbox',
        '#title' => t('<b>Response Signed:</b> This is a <b>Premium</b> feature.'
        . ' Check <a href="' . $base_url . '/admin/config/people/miniorange_saml_idp/licensing"><b>Licensing</b></a>'
        . ' Tab to learn more.'),
        '#disabled' => TRUE,
      );


      $form['miniorange_saml_idp_encrypt_signed'] = array(
        '#type' => 'checkbox',
        '#title' => t('<b>Encrypted Assertion:</b> This is a <b>Premium</b> feature.'
        . ' Check <a href="' . $base_url . '/admin/config/people/miniorange_saml_idp/licensing"><b>Licensing</b></a>'
        . ' Tab to learn more.'),
        '#disabled' => TRUE,
      );
      $form['miniorange_saml_idp_assertion_signed_start'] = array(
          '#markup' => '</div><br><div id="assertion_signed">'
      );

      $form['miniorange_saml_idp_assertion_signed'] = array(
        '#type' => 'checkbox',
        '#title' => t('<b>Assertion Signed</b> (Check If you want to sign SAML Assertion.)'),
        '#default_value' => \Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_idp_assertion_signed'),
      );

      $form['miniorange_saml_idp_buttons'] = array(
        '#markup' => '</div><br><br>'
      );

      $form['miniorange_saml_idp_config_submit'] = array(
        '#type' => 'submit',
        '#value' => t('Save Configuration'),
        '#attributes' => array('style' => 'border-radius:4px;background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;box-shadow: 0 1px 0 #337ab7;border-color: #337ab7 #337ab7 #337ab7;'),
      );

      $form['miniorange_saml_idp_config_delete'] = array(
          '#type' => 'submit',
          '#value' => t('Delete Configuration'),
          '#submit' => array('::miniorange_saml_idp_delete_idp_config'),
          '#attributes' => array('style' => 'border-radius:4px;background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;box-shadow: 0 1px 0 #337ab7;border-color: #337ab7 #337ab7 #337ab7;'),
      );

      $testConfigUrl = "\'" . $this->getTestUrl() . "\'";
      $form['miniorange_saml_idp_test_config_button'] = array (
          '#attached' => array(
             'library' => 'miniorange_saml_idp/miniorange_saml_idp.test',
         ),
          '#markup' => '<a id="testConfigButton" class="btn btn-primary btn-sm" onclick="testIdpConfig($testConfigUrl);"><b>Test Configuration</b></a><br><br></div></div></div>',
      );

      Utilities::spConfigGuide($form, $form_state);


      $form['miniorange_idp_guide_link_end'] = array(
          '#markup' => '</div>',
      );

      Utilities::AddSupportButton($form, $form_state);

  return $form;
 }

 function getTestUrl() {
    global $base_url;
    $testUrl = $base_url . '/?q=testConfig';
    return $testUrl;
 }

 
 function submitForm(array &$form, \Drupal\Core\Form\FormStateInterface $form_state)
 {
         global $base_url;
         $sp_name = $form['miniorange_saml_idp_name']['#value'];
         $issuer = $form['miniorange_saml_idp_entity_id']['#value'];
         $acs_url = $form['miniorange_saml_idp_acs_url']['#value'];
         $relay_state = $form['miniorange_saml_idp_relay_state']['#value'];
         $nameid_format = $form['miniorange_saml_idp_nameid_format']['#value'];
         $is_assertion_signed = $form['miniorange_saml_idp_assertion_signed']['#value'] == 1 ? TRUE : FALSE;

     if(empty($sp_name)||empty($issuer)||empty($acs_url)){
         drupal_set_message(t('The <b>Service Provider Name, SP Entity ID or Issuer, ACS URL</b> field is required.'), 'error');
         return;
     }

         \Drupal::configFactory()->getEditable('miniorange_saml_idp.settings')->set('miniorange_saml_idp_name', $sp_name)->save();
         \Drupal::configFactory()->getEditable('miniorange_saml_idp.settings')->set('miniorange_saml_idp_entity_id', $issuer)->save();
         \Drupal::configFactory()->getEditable('miniorange_saml_idp.settings')->set('miniorange_saml_idp_acs_url', $acs_url)->save();
         \Drupal::configFactory()->getEditable('miniorange_saml_idp.settings')->set('miniorange_saml_idp_relay_state', $relay_state)->save();
         \Drupal::configFactory()->getEditable('miniorange_saml_idp.settings')->set('miniorange_saml_idp_nameid_format', $nameid_format)->save();
         \Drupal::configFactory()->getEditable('miniorange_saml_idp.settings')->set('miniorange_saml_idp_assertion_signed', $is_assertion_signed)->save();
         drupal_set_message(t('Your Service Provider Configuration are successfully saved. You can click on Test Configuration button below to test these configurations.'));
 }

    function miniorange_saml_idp_delete_idp_config(array &$form, \Drupal\Core\Form\FormStateInterface $form_state)
    {
        \Drupal::configFactory()->getEditable('miniorange_saml_idp.settings')->clear('miniorange_saml_idp_name')->save();
        \Drupal::configFactory()->getEditable('miniorange_saml_idp.settings')->clear('miniorange_saml_idp_entity_id')->save();
        \Drupal::configFactory()->getEditable('miniorange_saml_idp.settings')->clear('miniorange_saml_idp_acs_url')->save();
        \Drupal::configFactory()->getEditable('miniorange_saml_idp.settings')->clear('miniorange_saml_idp_assertion_signed')->save();
        \Drupal::configFactory()->getEditable('miniorange_saml_idp.settings')->clear('miniorange_saml_idp_relay_state')->save();
        drupal_set_message(t('Service Provider Configuration successfully deleted.'));
    }
   function saved_support($form, \Drupal\Core\Form\FormStateInterface $form_state)
   {
        $email = $form['miniorange_saml_email_address_support']['#value'];
        $phone = $form['miniorange_saml_phone_number_support']['#value'];
        $query = $form['miniorange_saml_support_query_support']['#value'];
        Utilities::send_support_query($email, $phone, $query);
   }

    function miniorange_saml_upload_file(array &$form, \Drupal\Core\Form\FormStateInterface $form_state) {
        $idp_name = $form['miniorange_saml_idp_name_3']['#value'];
        if(empty($idp_name)&&empty(\Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_idp_name'))){
            drupal_set_message(t('Service Provider Name is required.'),error);
            return;
        }
        $file_name = $_FILES['files']['tmp_name']['metadata_file'];
        $file = file_get_contents($file_name);
        $this->upload_metadata($file, $idp_name, $type = 'file');
    }

    function miniorange_saml_fetch_metadata(array &$form, \Drupal\Core\Form\FormStateInterface $form_state) {
        $idp_name = $form['miniorange_saml_idp_name_3']['#value'];
        if(empty($idp_name)&&empty(\Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_idp_name'))){
            drupal_set_message(t('Service Provider Name is required.'),error);
            return;
        }
       $url = filter_var($form['metadata_URL']['#value'],FILTER_SANITIZE_URL);
       $arrContextOptions=array(
            "ssl"=>array(
                "verify_peer"=>false,
                "verify_peer_name"=>false,
            ),
       );
       $file = file_get_contents($url, false, stream_context_create($arrContextOptions));
       $this->upload_metadata($file, $idp_name, $type = 'URL');
    }

    public function upload_metadata($file, $idp_name, $type){

        $document = new \DOMDocument();
        $document->loadXML($file);
        restore_error_handler();
        $first_child = $document->firstChild;
        if(!empty($first_child)) {
            $metadata = new MetadataReader($document);
            $service_providers = $metadata->getServiceProviders();
            if(empty($service_providers)) {
                drupal_set_message(t('Please provide a valid metadata '.$type.'.'),error);
                return;
            }
            foreach($service_providers as $key => $sp) {
                $entityID_issuer = $sp->getEntityID();
                $acs_url = $sp->getAcsURL();
                //$is_assertion_signed = $sp->getAssertionsSigned();
                $is_assertion_signed = $sp->getAssertionsSigned() == 'true' ? TRUE : FALSE;
                if(!empty(\Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_idp_name'))&& empty($idp_name)){
                    $idp_name = \Drupal::config('miniorange_saml_idp.settings')->get('miniorange_saml_idp_name');
                    \Drupal::configFactory()->getEditable('miniorange_saml_idp.settings')->set('miniorange_saml_idp_name', $idp_name)->save();
                }
                else{
                    \Drupal::configFactory()->getEditable('miniorange_saml_idp.settings')->set('miniorange_saml_idp_name', $idp_name)->save();
                }
                \Drupal::configFactory()->getEditable('miniorange_saml_idp.settings')->set('miniorange_saml_idp_entity_id', $entityID_issuer)->save();
                \Drupal::configFactory()->getEditable('miniorange_saml_idp.settings')->set('miniorange_saml_idp_acs_url', $acs_url)->save();
                \Drupal::configFactory()->getEditable('miniorange_saml_idp.settings')->set('miniorange_saml_idp_assertion_signed', $is_assertion_signed)->save();
            }
            drupal_set_message(t('Service Provider Configuration successfully saved.'));
            return;
        }else {
            drupal_set_message(t('Please provide a valid metadata '.$type.'.'),error);
            return;
        }
    }
}