<?php

/**
 * @file
 * Contains \Drupal\miniorange_saml_idp\Form\MiniorangeSPInformation.
 */

namespace Drupal\miniorange_saml_idp\Form;

use Drupal\Core\Form\FormBase;
use Drupal\miniorange_saml_idp\Utilities;

class MiniorangeSPInformation extends FormBase
{

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'miniorange_sp_setup';
  }
  public function buildForm(array $form, \Drupal\Core\Form\FormStateInterface $form_state)
  {
      global $base_url;
      Utilities::visual_tour_start($form, $form_state);
      $login_url = $base_url . '/initiatelogon';
      $issuer = $base_url . '/?q=admin/config/people/miniorange_saml_idp/';
      $module_path = drupal_get_path('module', 'miniorange_saml_idp');
      $issuer_id = isset($issuer_id) && !empty($issuer_id)? $issuer_id:$issuer;

      $form['markup_style_1'] = array(
            '#attached' => array(
                'library' => array(
                    'miniorange_saml_idp/miniorange_saml_idp_copy.icon',
                    'miniorange_saml_idp/miniorange_saml_idp.Vtour',
                )
            ),
            '#markup' => '<div class="mo_saml_table_layout_1">',
      );

      $form['miniorange_saml_idp_div_st'] = array(
          '#markup' => '<div class="mo_saml_table_layout mo_saml_container"><h3>IDENTITY PROVIDER&nbsp;&nbsp; 
                <a id="Restart_moTour" class="btn btn-danger btn-sm" onclick="Restart_moTour()">Take a Tour</a></h3><hr><br>',
      );

      $form['markup_idp_sp_1'] = array(
          '#markup' => '<b>You can provide this metadata URL to your Service Provider.</b><br/>',
      );

      $form['markup_idp_sp_2'] = array(
          '#markup' => '<div>
                            <div class="mo_saml_highlight_background_url_note" id="idp_metadata_url">
                                <code><b>
                                    <span>
                                        <a target="_blank" href="' . $base_url . '/moidp_metadata">' . $base_url . '/moidp_metadata</a>
                                    </span></b>
                                </code>
                            </div>
                            <img class ="fa fa-fw fa-lg fa-copy mo_copy mo-margin" src="'. $base_url.'/'.$module_path . '/includes/images/copy-regular.svg">
                        </div>',
      );

      $form['markup_idp_sp'] = array(
          '#markup' => '<div class = "mo_saml_text_center"><h3>OR</h3>',
      );

      $form['header'] = array(
          '#markup' => '<br><center><h3>You will need the following information to configure your Service Provider. Copy it and keep it handy.</h3></center>',
      );

      $form['mo_saml_attrs_list_idp'] = array(
          '#markup' => '<div class="table-responsive" style="font-family: sans-serif;font-size: 12px;" id="mo_idp_vt_conf_table">   
                <table class="mo_guide_table mo_guide_table-striped mo_copy_icon_not_center" style="border: 1px solid #ddd;max-width: 100%;border-collapse: collapse;">
                    <thead>
                        <tr>
                            <th class="mo_guide_text-center mo_td_values">ATTRIBUTE</th>
                            <th class="mo_guide_text-center mo_td_values">VALUE</th>   
                            <tbody style="font-size: 12px;color:gray;">     
                                <tr>
                                    <td style="font-weight:bold;padding: 15px;">IDP-Entity ID / Issuer</td>
                                    <td>						               
						               <span id="issuer_id">' . $issuer_id . '</span>						                 
                                       <img class ="fa fa-fw fa-pull-right fa-lg fa-copy mo_copy" src="'. $base_url.'/'.$module_path . '/includes/images/copy-regular.svg">			
						            </td>                                    
                                </tr>                                
                                <tr>
                                    <td style="font-weight:bold;padding: 15px;">SAML Login URL</td>
                                    <td>						               
						               <span id="login_url">' . $login_url . '</span>						                 
                                       <img class ="fa fa-fw fa-pull-right fa-lg fa-copy mo_copy" src="'. $base_url.'/'.$module_path . '/includes/images/copy-regular.svg">			
						            </td>                                    
                                </tr>
                                <tr>
                                    <td style="font-weight:bold;padding: 15px;">SAML Logout URL</td>
                                    <td>						               
						               Available in </b><a href="' . $base_url . '/admin/config/people/miniorange_saml_idp/licensing">Premium</a> version.		
						            </td>                                    
                                </tr>
                                <tr>
                                    <td style="font-weight:bold;padding: 15px;">Certificate (Optional)	</td>
                                    <td>						               
						                <a href="' . $base_url . '/' . $module_path . '/resources/idp-signing.crt">Download</a>   
						            </td>                                    
                                </tr> 
                                <tr>
                                    <td style="font-weight:bold;padding: 15px;">Response Signed</td>
                                    <td>						               
						               Available in </b><a href="' . $base_url . '/admin/config/people/miniorange_saml_idp/licensing">Premium</a> version.		
						            </td>
                                </tr>                                                                                        
                                <tr>
                                    <td style="font-weight:bold;padding: 15px;">Assertion Signed</td> 
                                    <td style="padding: 15px;">You can choose to sign your response in <a href="' . $base_url . '/admin/config/people/miniorange_saml_idp/idp_setup">Service Provider Setup</a></td>
                                </tr>                              
                            </tbody>                                                 
                        </tr>
                    </thead>
                    </table>
          </div>'
      );

      $form['miniorange_idp_guide_div_close'] = array(
          '#markup' => '</div></div>',
      );

      Utilities::spConfigGuide($form, $form_state);

      $form['miniorange_idp_guide_link_end'] = array(
          '#markup' => '</div>',
      );

      Utilities::AddSupportButton($form, $form_state);

      return $form;
  }

  public function submitForm(array &$form, \Drupal\Core\Form\FormStateInterface $form_state) {

  }

  function saved_support($form, &$form_state) {
        $email = $form['miniorange_saml_email_address_support']['#value'];
        $phone = $form['miniorange_saml_phone_number_support']['#value'];
        $query = $form['miniorange_saml_support_query_support']['#value'];
        Utilities::send_support_query($email, $phone, $query);
  }
}